<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
* CSVReader Class
*
* $Id: csvreader.php 147 2007-07-09 23:12:45Z Pierre-Jean $
*
* Allows to retrieve a CSV file content as a two dimensional array.
* The first text line shall contains the column names.
*
* @author        Pierre-Jean Turpeau
* @link        http://www.codeigniter.com/wiki/CSVReader
*/
class CSVReader {
    
    var $fields;        /** columns names retrieved after parsing */
    var $separator = ',';    /** separator used to explode each line */
    
    /**
     * Parse a text containing CSV formatted data.
     *
     * @access    public
     * @param    string
     * @return    array
     */
    function parse_text($p_Text) {
        $lines = explode("\n", $p_Text);
        return $this->parse_lines($lines);
    }
    
    /**
     * Parse a file containing CSV formatted data.
     *
     * @access    public
     * @param    string
     * @return    array
     */
    function parse_file($p_Filepath) {
        $lines = file($p_Filepath);
        return $this->parse_lines($lines);
    }
    /**
     * Parse an array of text lines containing CSV formatted data.
     *
     * @access    public
     * @param    array
     * @return    array
     */
    function parse_lines($p_CSVLines) {    
        $content = array();
        $a = array();
        $csvdata = array();
        foreach( $p_CSVLines as $line_num => $line ) {
              $temp  = explode(',',$line);
              foreach($temp as $k=>$v){
				     
				    $a[$line_num][$k]= $v;
			   }
        }
        // read header title
        $csvdata['header'] = $a[0][0];
        unset($a[0]); 
       // removing unwanted data 
        unset($a[2]);
        unset($a[1][0]); 
       
        // filtering data
        foreach($a[1] as $m=>$n) { 
		  if(trim($n)=='')
		    unset($a[1][$m]);
		}
		$dates = array();
        $dates = $a[1] ;
      
        unset($a[1]);
        $content = array();
       
       //   print_r($dates);
       
        foreach($dates as $key=>$val){
		   foreach($a as $t=>$s) 
		    {   
				if($s[0]!=''  and $a[$t][$key]!='' ) 
				 { 
						$content[$key][$t]['date'] = $val;
						$content[$key][$t]['time'] = $s[0];
						$content[$key][$t]['name'] = $a[$t][$key];
				 }
		   
		    }  
		    
		} 
		$csvdata['content'] = $content; 
		$csvdata['dates'] = $dates; 
        
        return $csvdata;
    }
}
