<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class admin extends CI_Controller {

 /*
  * Author: Suresh Koduri
  * Module : Gallery
  * add, update, delete functions
  * 
  */
	public function __construct() {
		parent::__construct();
		$this->lang->load("admin",  language_load()); 
		$this->lang->load("admin_gallery",  language_load()); 
		$this->load->model('admin_gallery_model');
	}  
	
	// gallery  index  
	public function index($type = '') {
		//Admin Login Check		
		if(!adminLoginCheck())
			redirect('admin','refresh');  
		if(!check_perm('gallery','r'))
			redirect('admin/permissions/denied');
		
		$data = array();
		$data = messageDisplay(); 
		
		//$type = $type? $type: 1;
	 	//$category_name = $this->admin_gallery_model->getGalleryCategoryName($type);	
		
		//$data['type'] = $type;
		//$data['list_type'] = $category_name;
	 $this->load->library('Datatables');
       $this->load->library('table');
		$this->load->model('admin_gallery_model');
         $temp  = $this->admin_gallery_model->userslist();
        $data['users'] = $temp;
        // $data['users'] = $temp 
         
		$data['validate_msgs'] = $this->load->view('admin/validate_message', $data, true); 
		
		$data['body'] = $this->load->view('gallery_list', $data, true);  
		$this->load->view('admin/layout',$data);
	}

	// Gallery lists
	public function galleryList() {
				
		if(!check_perm('gallery','r'))
			redirect('admin/permissions/denied');
		 
		
	   $this->load->library('Datatables');
       $this->load->library('table');
       
       echo  $this->admin_gallery_model->galleryList(); 
		exit;
	}
	public function viewImages()
	{
		$images =  $this->admin_gallery_model->userimages($this->uri->segment(4)); 
		if($images)
		  $data['images'] = $images;
		else
		   $data['images'] = '';
		   
		 $data['body'] = $this->load->view('userimages_list', $data, true);  
		$this->load->view('admin/layout',$data);
		 
	}
	// Add images to gallery
	public function addImages() {
		if(!check_perm('gallery','c'))
			redirect('admin/permissions/denied');
		
		$this->getForm();
	}
	
	public function getForm()
	{
		$data = array();
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
		 
          
       if ($this->input->post('gallery_title')) {
			$data['gallery_title'] = $this->input->post('gallery_title');
		} elseif (!empty($gallery)) {
			$data['gallery_title'] = $gallery->gallery_title;
		} else {
			$data['gallery_title'] = '';
		}
				
		if ($this->input->post('img_data')) { 
			$data['image_data'] = $this->input->post('img_data');
		} elseif (!empty($gallery)) {
			$img_array = '';
			  
			if($gallery->gallery_images != 'false' and $gallery->gallery_images!='')
			  {
			   $img = json_decode($gallery->gallery_images); 
			   $img_array = array();
					foreach($img as $k=>$v)
					{
					   foreach($v as $l=>$m)
					   { 
						 $img_array[$k][$l] = $m; 
						}
					}
			    
				}
			  
			 $data['image_data'] =  $img_array;
		} else {
			  $data['image_data'] = '';
		}
		 
		 
		
		$data['body'] = $this->load->view('add_photos', $data, true);  
		$this->load->view('admin/layout',$data);
	}
	
	// upload image(s) function 
	public function uploadImages($category_id)
	{
		 
		 
		$output_dir = "assets/images/uploads/";
		
		 
		//print_r($_FILES); exit;
		if(isset($_FILES["myfile"]))
		{
			$ret = array();

			$error =$_FILES["myfile"]["error"];
			//You need to handle  both cases
			//If Any browser does not support serializing of multiple files using FormData() 
			if(!is_array($_FILES["myfile"]["name"])) //single file
			{
				$fileArr = explode('.',$_FILES["myfile"]["name"]);
				 
			 
				$fileName = uniqid().strtotime("now")."_.".strtolower(trim(preg_replace('/\s*\([^)]*\)/', '', $fileArr[count($fileArr)-2])));
				 
				//$fileName = strtolower(trim(preg_replace('/\s*\([^)]*\)/', '', $fileArr[0])).strtotime("now").'.'.$fileArr[1]);
				move_uploaded_file($_FILES["myfile"]["tmp_name"],$output_dir.$fileName);
				$ret['title']= $fileName;
				$ret['img']= stripslashes($output_dir.$fileName);
			}
			else  //Multiple files, file[]
			{
				$fileCount = count($_FILES["myfile"]["name"]);
				for($i=0; $i < $fileCount; $i++)
				{
					$fileArr = explode('.',$_FILES["myfile"]["name"]);
					$fileName = uniqid().strtotime("now")."_.".strtolower(trim(preg_replace('/\s*\([^)]*\)/', '', $fileArr[count($fileArr)-2])));
					//$fileName = strtolower(trim(preg_replace('/\s*\([^)]*\)/', '', $fileArr[0])).strtotime("now").'.'.$fileArr[1]);
					move_uploaded_file($_FILES["myfile"]["tmp_name"][$i],$output_dir.$fileName);
					$ret['title']= $fileName;
					$ret['img']= stripslashes($output_dir.$fileName);
				}	
			}
			echo json_encode($ret);
		}
	}
    public function updatedUserImages()
    {
		  
		 $result = $this->admin_gallery_model->updatedUserImages($this->input->post('images'),$this->input->post('users'));
		 return;
	}
	// insert gallery function 
	public function insert() {
			 
		if(!check_perm('gallery','c'))
			redirect('admin/permissions/denied');
		
		if($this->input->server('REQUEST_METHOD') == 'POST') {
				 
			$arr=array();
			//$arr['gallery_title'] = stripslashes(mysql_real_escape_string($this->input->post('gallery_title')));
			$img_array = array();
			$img_arr = $this->input->post('img_data');
			 
			//$arr['gallery_images']    = stripslashes(json_encode($this->input->post('img_data')));
			//$arr['gallery_images_count']    = count($this->input->post('img_data'));
			//$arr['gallery_status']     = 'ACTIVE';
			//$order = $this->admin_gallery_model->getmaxorder();
			//$arr['gallery_order']     = (int) $order + 1;		
			//$arr['gallery_category_id'] = $this->input->post('gallery_type');
			$arr['created_date']    = date('Y-m-d H:i:s');
			$arr['created_by']      =  userdata('admin_id');
            $arr['modified_date']    = date('Y-m-d H:i:s');
			$arr['modified_by']      =  userdata('admin_id'); 
			 
			$result = $this->admin_gallery_model->saveData($arr,$img_arr);
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_gallery_insert_success'));
				redirect('admin/gallery/index');
			} else{
				//$this->session->set_userdata('error_msg',$this->lang->line('admin_gallery_exists'));
				//$this->getForm($this->input->post('gallery_type'),'');
			}	
						
		} else { 
				//$this->getForm($this->input->post('gallery_type'),'');
		}
			  
	}
	// update gallery function
	public function update() {
		if(!check_perm('gallery','u'))
			redirect('admin/permissions/denied');
		
		if($this->galleryValidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') {
			
			$arr=array();
			$arr['gallery_title'] = stripslashes(mysql_real_escape_string($this->input->post('gallery_title')));
			$img_array = array();
			$img_arr = $this->input->post('image_data');
			print_r($this->input->post('img_data'));
			$arr['gallery_images']    = stripslashes(json_encode($this->input->post('img_data')));
			$arr['gallery_images_count']    = count($this->input->post('img_data'));
			$arr['gallery_category_id'] = $this->input->post('gallery_type');
			$arr['modified_date']    = date('Y-m-d H:i:s');
			$arr['modified_by']      =  userdata('admin_id'); 
			$arr['gallery_id']      = $this->input->post('gallery_id');
			//print_r($arr);
			$result = $this->admin_gallery_model->updateGallery($arr);
			//print_r($result);
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_gallery_update_success'));
 				redirect('admin/gallery/index/'.$arr['gallery_category_id']);
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_gallery_exists'));
				$this->getForm($this->input->post('gallery_type'),$this->input->post('gallery_id'));
			}			
		} 
		else
		{
 			 $this->getForm($this->input->post('gallery_type'),$this->input->post('gallery_id'));    
		}
		 
	}
	
	// edit gallery function 
	public function edit($type='',$id='')
	{
		if(!check_perm('gallery','u'))
			redirect('admin/permissions/denied');
		$this->getForm($type, $id);
		
	}
	// server side validation     
    public function galleryValidateForm()
	{
           $this->form_validation->set_rules('gallery_title','Title','required');
                      
           if ($this->form_validation->run() == FALSE){
                 return false;
           }else{
                 return true;
            }
         
    }
	
	// delete gallery function 
	public function delete()
	{
		if(!check_perm('gallery','d'))
			redirect('admin/permissions/denied');
		
		$result = $this->admin_gallery_model->deleteGallery($this->input->post('id'));
        echo "deleted";
		exit;
        exit;
	}
	
	public function active() {  
		if(!check_perm('gallery','u'))
			redirect('admin/permissions/denied');
		
		$result = $this->admin_gallery_model->activeGallery($this->input->post('id')); 
		echo "activated";
		exit; 
	}
	
	public function inactive()
	{
		if(!check_perm('gallery','u'))
			redirect('admin/permissions/denied');
		
		$result = $this->admin_gallery_model->inactiveGallery($this->input->post('id')); 
		echo "inactivated";
		exit; 
	}
	public function favorite() {  
		if(!check_perm('gallery','u'))
			redirect('permissions/denied');
		
		$result = $this->admin_gallery_model->favoriteGallery($this->input->post('id')); 
		echo "favorite";
		exit; 
	}
	public function unfavorite() {  
		if(!check_perm('gallery','u'))
			redirect('permissions/denied');
		
		$result = $this->admin_gallery_model->unfavoriteGallery($this->input->post('id')); 
		echo "unfavorite";
		exit; 
	}
	// update gallery order 
	public function updateOrder($cid)
	{
		if(!check_perm('gallery','u'))
			redirect('admin/permissions/denied');
		
		$data = $this->input->post('item');
		foreach($data as $order => $val){
			$order++;
			$gid = explode('_',$val);
			$this->admin_gallery_model->update_sort_index($gid[1], $cid, $order);
		}
		echo 'success';
	}
	
	public function postOnFbWall(){ 
		
	  if(!check_perm('gallery','f'))
			redirect('admin/permissions/denied');
			
	   // set call back url for module
	   $this->session->set_userdata('callbackurl','admin/gallery/postOnFbWall/'.$this->uri->segment(4));
	   $this->load->model('news/admin_news_model');
	   $gallery_id = $this->uri->segment(4);
	   //$this->session->unset_userdata('post_item_id');
	   $result = $this->admin_gallery_model->getGalleryDetails($gallery_id);
	   $gallery=$result[0];
	   if($result)
		{ 
		 
		  $fbdata =array();
		 
		  if($gallery->gallery_status=='ACTIVE')
		   {
		 // post fb data format on wall
			 if($gallery->gallery_title!='')
			   {
				 $category_name = str_replace(" ","-",strtolower($this->admin_gallery_model->getGalleryCategoryName($gallery->gallery_category_id))); 
				 $link =  base_url().'gallery/'.$category_name.'/'.str_replace(" ","-",strtolower($gallery->gallery_title)); 
			     $fbdata['name'] =  $gallery->gallery_title;
			     $fbdata['link'] =  $link;
			     $fbdata['description'] =  strip_tags(stripslashes($gallery->gallery_title));
			      
			   } 
			  
			  
			    
			 if($gallery->gallery_images!='')
			  {
			     $images = json_decode($gallery->gallery_images);
			    $img = current((array)$images); 
			    if(isset($img->img ) && $img->img!='')
			       $fbdata['picture'] = base_url().$img->img;
			 } 
	         $post = postOnFb($fbdata);
	        
	        if($post)
	         $this->session->set_userdata('success_msg','Successfully posted on facebook wall'); 
	        }else{
		        $this->session->set_userdata('error_msg',$this->lang->line('Active this record to publish on facebook'));
		   }
	        
	     }else{
		     $this->session->set_userdata('error_msg',$this->lang->line('News does not exits in our records'));
  		 } 
  		 
  		 
		 $this->index($gallery->gallery_category_id);
	}
			
}
