<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class admin extends CI_Controller {

 /*
  * Author: Surendra
  * Module : role
  * adding adduser,update,delete functions
  * 
  */
	public function __construct() 
    {
		parent::__construct();
		//Admin Login Check
		
		if(!adminLoginCheck())
			redirect('admin','refresh'); 
		$this->lang->load("admin",  language_load()); 
		$this->lang->load("admin_roles",  language_load()); 
	}  
	
	// roles listing 
	public function index()
	{   
		if(!check_perm('role','r'))
		     redirect('admin/permissions/denied');
		     
		$data = array();
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
		$data['body'] = $this->load->view('admin_role_list', $data, true);  
		$this->load->view('admin/layout',$data);
	}
	public function roleslist(){
		
		if(!check_perm('role','r'))
		     redirect('admin/permissions/denied');
		     
		$this->load->library('Datatables');
        $this->load->library('table');
        $this->load->model('admin_role_model');
		echo  $this->admin_role_model->rolelist(); 
		exit;
	}
	
	// add role 
	public function addrole()
	{  
		 if(!check_perm('role','c'))
		     redirect('admin/permissions/denied');
		$this->getForm(); 
	}
		// edit role
	public function edit() {  
		
		if(!check_perm('role','u'))
		     redirect('admin/permissions/denied');
		$this->getForm(); 
	} 
		// insert role
	public function insert() {
		
	    if(!check_perm('role','c'))
		     redirect('admin/permissions/denied');
		     
		if($this->rolevalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') {
				
			$arr=array();
			$arr['role_name'] = trim($this->input->post('role_name'));
			$arr['role_details']    = $this->input->post('role_description');
			// checking persmisson coditions
			$permdata = $this->input->post('role_perm');
			
			$filterdata_perm = array();
			 
			if(isset($permdata) && count($permdata)>0 && $permdata!='')
			{ 
					foreach($permdata as $mod=>$perm)
					{
						 
						 if(!isset($perm['r']))
						 {
							   if(isset($perm['c']) || isset($perm['u']) || isset($perm['d'] ))
								$perm['r'] = 1 ;
								
						 }
						 $filterdata_perm[$mod] = $perm ; 
					}
			 } 
			 // checking persmisson coditions end
			$arr['role_permissions']    = json_encode($filterdata_perm);
			$arr['role_status']     = $this->input->post('role_status'); 
			$arr['created_date']    = date('Y-m-d H:i:s');
			$arr['created_by']      =  userdata('admin_id'); 
			$this->load->model('admin_role_model'); 
			$result = $this->admin_role_model->saveData($arr);
				
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_roles_insert_success'));
				$this->index();
			} else{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_roles_exists'));
				$this->getForm();
			}	
						
		} else { 
				$this->getForm();
		}
			  
	}
	
	// update role
    public function update() {
		if(!check_perm('role','u'))
		     redirect('admin/permissions/denied');
		if($this->rolevalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') {
			
			$arr=array();
			$arr['role_name']       = trim($this->input->post('role_name'));
			$arr['role_details']    = $this->input->post('role_description');
			$arr['role_status']     = $this->input->post('role_status'); 
			// checking persmisson coditions
			$permdata = $this->input->post('role_perm');
			$filterdata_perm = array();
			if(isset($permdata) && count($permdata)>0 && $permdata!='')
			{
					foreach($permdata as $mod=>$perm)
					{
						 
						 if(!isset($perm['r']))
						 {
							   if(isset($perm['c']) || isset($perm['u']) || isset($perm['d']  ))
								$perm['r'] = 1 ;
								
						 }
						 $filterdata_perm[$mod] = $perm ; 
					}
			 } 
			 
			 // checking persmisson coditions end
			$arr['role_permissions']    = json_encode($filterdata_perm);
			$arr['modified_date']    = date('Y-m-d H:i:s');
			$arr['modified_by']      =  userdata('admin_id'); 
			$arr['role_id']         = $this->input->post('role_id');
				 				 
			$this->load->model('admin_role_model');
			
			$result = $this->admin_role_model->roleUpdate($arr);
			
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_roles_update_success'));
  				 redirect('admin/roles');
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_roles_exists'));
  				$this->getForm($this->input->post('role_id'));
			}			
		} 
		else
		{
 			 $this->getForm($this->input->post('role_id'));    
		}
		 
	}
	
    public function getForm($id = '') {
        
        $data=array();
        $data = messageDisplay();
        $data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
        // label data from languages 
		
        $id = $id; 
        if($this->uri->segment(4))
        $id = $this->uri->segment(4);
        
         if ($id!='' && ($this->input->server('REQUEST_METHOD') != 'POST')) {  
			$role_id=$id;
			if($id==1)
			{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_roles_super_user_erroe'));  
				redirect('admin/roles');
		    }
			$this->load->model('admin_role_model');
			$result = $this->admin_role_model->editRole($role_id);
			if($result)
			$role=$result[0];
			else
			{
				 $this->session->set_userdata('error_msg',$this->lang->line('admin_roles_not_exist'));  
				 $this->index();
			}
        		
        }
       
       if ($this->input->post('role_id')) {
        		$data['role_id'] = $this->input->post('role_id');
           } elseif (!empty($role)) {
        		$data['role_id'] = $role->role_id;
           } else {
        		$data['role_id'] = '';
        }
        if ($this->input->post('role_name')) {
			$data['role_name'] = $this->input->post('role_name');
		} elseif (!empty($role)) {
			$data['role_name'] = $role->role_name;
		} else {
			$data['role_name'] = '';
		}
		
		if ($this->input->post('role_description')) {
			$data['role_description'] = $this->input->post('role_description');
		} elseif (!empty($role)) {
			$data['role_description'] = $role->role_details;
		} else {
			$data['role_description'] = '';
		}
		if ($this->input->post('role_perm')) { 
			$data['role_perm'] = $this->input->post('role_perm'); 
			 
		} elseif (!empty($role)) {
			$perm_array = '';
			  
			if($role->role_permissions != 'false' and $role->role_permissions!='')
			  {
			   $perm = json_decode($role->role_permissions); 
			   $perm_array = array();
				 foreach($perm as $k=>$v)
				  {
					   foreach($v as $l=>$m)
					   { 
						 $perm_array[$k][$l] = $m; 
						}
				  }
			    } 
			  
			 $data['role_perm'] =  $perm_array;
		} else {
			$data['role_perm'] = '';
		}
		 
		if ($this->input->post('role_status')) {
			$data['role_status'] = $this->input->post('role_status');
		} elseif (!empty($role)) {
			$data['role_status'] = $role->role_status;
		} else {
			$data['role_status'] = '';
		}
		   
		$data['body'] = $this->load->view('admin_addrole',$data,true);
		$this->load->view('admin/layout',$data);
        	 

        }
   // server side validation     
    public function rolevalidateForm()
        {
           $this->form_validation->set_rules('role_name','Role Name','required');
           $this->form_validation->set_rules('role_description','Role Description','required');
           $this->form_validation->set_rules('role_status','Role Status','required');
           
           if ($this->form_validation->run() == FALSE){
                 return false;
           }else{
                 return true;
            }
         
    }
	// active roles
	public function active() { 
		
		if(!check_perm('role','u'))
		     redirect('admin/permissions/denied'); 
		$this->load->model('admin_role_model');  
		$result = $this->admin_role_model->activeRole($this->input->post('id')); 
		echo "activated";
		exit; 
	}
	// inactive roles
	public function inactive()
	{
		if(!check_perm('role','u'))
		     redirect('admin/permissions/denied');
		$this->load->model('admin_role_model'); 
		$result = $this->admin_role_model->inactiveRole($this->input->post('id')); 
		echo "inactivated";
		  exit; 
	}
	// delete roles
	public function delete() {
		if(!check_perm('role','d'))
		     redirect('admin/permissions/denied'); 
		$this->load->model('admin_role_model'); 
		$result = $this->admin_role_model->deleteRole($this->input->post('id'));
        echo "deleted";
		exit;
	}
	
 
}
