<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class admin extends CI_Controller {

	/*
	 * 
	 * Module : User
	 * add,update,delete,active and inactive user
	 * 
	 */
	 
	public function __construct() {
	    parent::__construct();
	    
	    if(!adminLoginCheck())
			redirect('admin','refresh'); 
	    $this->lang->load("admin", language_load());
	    $this->lang->load("adminusers", language_load());
	}
			
	/*
	 * 	  
	 * Users Management
	 *  
	 */
	
	
	//Users Listing
	public function index()
	{	
		if(!check_perm('user','r'))
		     redirect('admin/permissions/denied');	
		     
        $data = array();
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true);
		//$data['list'] = $this->adminusermodel->userslist();
		$data['body'] = $this->load->view('userslist', $data, true); 
		$this->load->view('admin/layout',$data);
	}
	
	public function userslist()
	{	
		if(!check_perm('user','r'))
		     redirect('admin/permissions/denied');
		     			
		$this->load->library('Datatables');
        $this->load->library('table');
        $this->load->model('adminusermodel');
		echo  $this->adminusermodel->userslist(); 
		exit;
	}
	
	//Add user
	public function adduser()
	{
		if(!check_perm('user','c'))
		     redirect('admin/permissions/denied');
		$this->getForm(); 
	}
	
	//Edit user
	public function edit()
	{   
		if(!check_perm('user','u'))
		     redirect('admin/permissions/denied');
		$this->getForm(); 
	} 
	
	//Insert user data
	public function insert()
	{	
		if(!check_perm('user','c'))
		     redirect('admin/permissions/denied');
		     	 
		if($this->uservalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') 
		{
			$arr=array();
			$temp = $this->session->userdata('admin_user_data');
			$arr['admin_email'] = $this->input->post('useremail');
			$arr['admin_password'] = md5($this->input->post('pass'));
			$arr['admin_displayname']       = $this->input->post('displayname');
			$arr['admin_status']      = $this->input->post('userstatus');
			$arr['role_id']        = $this->input->post('userrole');
			$arr['created_by'] = $temp->admin_id;
			$arr['created_date'] = date('Y-m-d H:i:s');

			$this->load->model('adminusermodel');
			$result = $this->adminusermodel->saveUserdata($arr);	

			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('adminusers_insertsuccessfully'));
				$this->index();
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('adminusers_emailalreadyexits'));
				
				$this->getForm();
			}			 						 				
		}	
		else
		{ 
			$this->getForm();
		}																 										
	}
			
	//Update user form
	public function update()
	{
		if(!check_perm('user','u'))
		     redirect('admin/permissions/denied');
		     
		if($this->uservalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST')
		{
		$arr=array();
		$temp = $this->session->userdata('admin_user_data');
		$arr['admin_email'] = $this->input->post('useremail');
 		$arr['admin_displayname']       = $this->input->post('displayname');
 		if($this->input->post('pass')){
			$arr['admin_password'] = md5($this->input->post('pass'));
		}
		$arr['admin_status']      = $this->input->post('userstatus');
		$arr['role_id']        = $this->input->post('userrole');
		$arr['admin_id']        = $this->input->post('admin_id');
		$arr['modified_by'] = $temp->admin_id;
		$arr['modified_date'] = date('Y-m-d H:i:s');

		$this->load->model('adminusermodel');
		$result = $this->adminusermodel->updateUserdata($arr);	
		
		if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('adminusers_updated'));
  				 redirect('admin/users');
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('adminusers_emailalreadyexits'));
  				$this->getForm($this->input->post('admin_id'));
			}										
	   }
	   else
	   {
 		 $this->getForm($this->input->post('admin_id'));    
	   }
	}
	
	
	//Generate values for newuser and edituser form 
	public function getForm($id = '')
    {     
		$data=array();
        $data = messageDisplay();
        $data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
        
        $this->load->model('adminusermodel');
		$data['rolesdata'] = $this->adminusermodel->getRolesList();
		
        $id = $id; 
        if($this->uri->segment(4))
        $id = $this->uri->segment(4);
        
        
       
         if ($id!='' && ($this->input->server('REQUEST_METHOD') != 'POST')) {  
			$admin_id = $id;
			$this->load->model('adminusermodel');
			$result = $this->adminusermodel->useredit($admin_id);
			if($result)
			$user=$result[0];
			else
			{
				 $this->session->set_userdata('error_msg',$this->lang->line('admin_roles_not_exist'));  
				 $this->index();
			}
        }
      
       if ($this->input->post('admin_id')) {
         		$data['admin_id'] = $this->input->post('admin_id');        		
           } elseif (!empty($user)) {
         		$data['admin_id'] = $user->admin_id;
           } else {
         		$data['admin_id'] = '';
        }
        
        if ($this->input->post('displayname')) {
			$data['admin_displayname'] = $this->input->post('displayname');
		} elseif (!empty($user)) {
			$data['admin_displayname'] = $user->admin_displayname;			
		} else {
			$data['admin_displayname'] = '';
		}
		
		if ($this->input->post('useremail')) {
			$data['admin_email'] = $this->input->post('useremail');
		} elseif (!empty($user)) {
			$data['admin_email'] = $user->admin_email;			
		} else {
			$data['admin_email'] = '';
		}
		 
		if ($this->input->post('userstatus')) {
			$data['admin_status'] = $this->input->post('userstatus');
		} elseif (!empty($user)) {
			$data['admin_status'] = $user->admin_status;
		} else {
			$data['admin_status'] = '';
		}
		
		if ($this->input->post('userrole')) {
			$data['role_id'] = $this->input->post('userrole');
		} elseif (!empty($user)) {
			$data['role_id'] = $user->role_id;
		} else {
			$data['role_id'] = '';
		}  
		  
		$data['body'] = $this->load->view('adduser',$data,true);
		$this->load->view('admin/layout',$data);        	 
    }
        
    // server side validation     
    public function uservalidateForm()
    {
		$this->form_validation->set_rules('displayname','Display Name','required');
		$this->form_validation->set_rules('useremail','User Email','required');
		$this->form_validation->set_rules('userstatus','User Status','required');
		$this->form_validation->set_rules('userrole','User Role','required');

		if ($this->form_validation->run() == FALSE){
			return false;
		}else{
			return true;
		}         
    }
	
	//Active Users
	public function active() { 
		if(!check_perm('user','u'))
		     redirect('admin/permissions/denied');
		     
		$this->load->model('adminusermodel');  
		$result = $this->adminusermodel->activeUser($this->input->post('id')); 
		echo "activated";
		exit; 
	}
	
	//Inactive Users
	public function inactive()
	{
		if(!check_perm('user','u'))
		     redirect('admin/permissions/denied');
		$this->load->model('adminusermodel'); 
		$result = $this->adminusermodel->inactiveUser($this->input->post('id')); 
		echo "inactivated";
		  exit; 
	}
	
	//Delete Users
	public function delete() { 
		
		if(!check_perm('user','d'))
		     redirect('admin/permissions/denied');
		     
		$this->load->model('adminusermodel'); 
		$result = $this->adminusermodel->deleteUser($this->input->post('id'));
        echo "deleted";
		exit;
	}
}
